//------------------------------------------------------------------------------
// <auto-generated />
//
// This file was automatically generated by SWIG (http://www.swig.org).
// Version 3.0.12
//
// Do not make changes to this file unless you know what you are doing--modify
// the SWIG interface file instead.
//------------------------------------------------------------------------------

namespace OpenMMNET {

public class CustomHbondForce : Force {
  private global::System.Runtime.InteropServices.HandleRef swigCPtr;

  internal CustomHbondForce(global::System.IntPtr cPtr, bool cMemoryOwn) : base(OpenMMSwigPINVOKE.CustomHbondForce_SWIGUpcast(cPtr), cMemoryOwn) {
    swigCPtr = new global::System.Runtime.InteropServices.HandleRef(this, cPtr);
  }

  internal static global::System.Runtime.InteropServices.HandleRef getCPtr(CustomHbondForce obj) {
    return (obj == null) ? new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero) : obj.swigCPtr;
  }

  ~CustomHbondForce() {
    Dispose();
  }

  public override void Dispose() {
    lock(this) {
      if (swigCPtr.Handle != global::System.IntPtr.Zero) {
        if (swigCMemOwn) {
          swigCMemOwn = false;
          OpenMMSwigPINVOKE.delete_CustomHbondForce(swigCPtr);
        }
        swigCPtr = new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero);
      }
      global::System.GC.SuppressFinalize(this);
      base.Dispose();
    }
  }

  public CustomHbondForce(string energy) : this(OpenMMSwigPINVOKE.new_CustomHbondForce(energy), true) {
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public int getNumDonors() {
    int ret = OpenMMSwigPINVOKE.CustomHbondForce_getNumDonors(swigCPtr);
    return ret;
  }

  public int getNumAcceptors() {
    int ret = OpenMMSwigPINVOKE.CustomHbondForce_getNumAcceptors(swigCPtr);
    return ret;
  }

  public int getNumExclusions() {
    int ret = OpenMMSwigPINVOKE.CustomHbondForce_getNumExclusions(swigCPtr);
    return ret;
  }

  public int getNumPerDonorParameters() {
    int ret = OpenMMSwigPINVOKE.CustomHbondForce_getNumPerDonorParameters(swigCPtr);
    return ret;
  }

  public int getNumPerAcceptorParameters() {
    int ret = OpenMMSwigPINVOKE.CustomHbondForce_getNumPerAcceptorParameters(swigCPtr);
    return ret;
  }

  public int getNumGlobalParameters() {
    int ret = OpenMMSwigPINVOKE.CustomHbondForce_getNumGlobalParameters(swigCPtr);
    return ret;
  }

  public int getNumTabulatedFunctions() {
    int ret = OpenMMSwigPINVOKE.CustomHbondForce_getNumTabulatedFunctions(swigCPtr);
    return ret;
  }

  public int getNumFunctions() {
    int ret = OpenMMSwigPINVOKE.CustomHbondForce_getNumFunctions(swigCPtr);
    return ret;
  }

  public string getEnergyFunction() {
    string ret = OpenMMSwigPINVOKE.CustomHbondForce_getEnergyFunction(swigCPtr);
    return ret;
  }

  public void setEnergyFunction(string energy) {
    OpenMMSwigPINVOKE.CustomHbondForce_setEnergyFunction(swigCPtr, energy);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public CustomHbondForce.NonbondedMethod getNonbondedMethod() {
    CustomHbondForce.NonbondedMethod ret = (CustomHbondForce.NonbondedMethod)OpenMMSwigPINVOKE.CustomHbondForce_getNonbondedMethod(swigCPtr);
    return ret;
  }

  public void setNonbondedMethod(CustomHbondForce.NonbondedMethod method) {
    OpenMMSwigPINVOKE.CustomHbondForce_setNonbondedMethod(swigCPtr, (int)method);
  }

  public double getCutoffDistance() {
    double ret = OpenMMSwigPINVOKE.CustomHbondForce_getCutoffDistance(swigCPtr);
    return ret;
  }

  public void setCutoffDistance(double distance) {
    OpenMMSwigPINVOKE.CustomHbondForce_setCutoffDistance(swigCPtr, distance);
  }

  public int addPerDonorParameter(string name) {
    int ret = OpenMMSwigPINVOKE.CustomHbondForce_addPerDonorParameter(swigCPtr, name);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public string getPerDonorParameterName(int index) {
    string ret = OpenMMSwigPINVOKE.CustomHbondForce_getPerDonorParameterName(swigCPtr, index);
    return ret;
  }

  public void setPerDonorParameterName(int index, string name) {
    OpenMMSwigPINVOKE.CustomHbondForce_setPerDonorParameterName(swigCPtr, index, name);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public int addPerAcceptorParameter(string name) {
    int ret = OpenMMSwigPINVOKE.CustomHbondForce_addPerAcceptorParameter(swigCPtr, name);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public string getPerAcceptorParameterName(int index) {
    string ret = OpenMMSwigPINVOKE.CustomHbondForce_getPerAcceptorParameterName(swigCPtr, index);
    return ret;
  }

  public void setPerAcceptorParameterName(int index, string name) {
    OpenMMSwigPINVOKE.CustomHbondForce_setPerAcceptorParameterName(swigCPtr, index, name);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public int addGlobalParameter(string name, double defaultValue) {
    int ret = OpenMMSwigPINVOKE.CustomHbondForce_addGlobalParameter(swigCPtr, name, defaultValue);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public string getGlobalParameterName(int index) {
    string ret = OpenMMSwigPINVOKE.CustomHbondForce_getGlobalParameterName(swigCPtr, index);
    return ret;
  }

  public void setGlobalParameterName(int index, string name) {
    OpenMMSwigPINVOKE.CustomHbondForce_setGlobalParameterName(swigCPtr, index, name);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public double getGlobalParameterDefaultValue(int index) {
    double ret = OpenMMSwigPINVOKE.CustomHbondForce_getGlobalParameterDefaultValue(swigCPtr, index);
    return ret;
  }

  public void setGlobalParameterDefaultValue(int index, double defaultValue) {
    OpenMMSwigPINVOKE.CustomHbondForce_setGlobalParameterDefaultValue(swigCPtr, index, defaultValue);
  }

  public int addDonor(int d1, int d2, int d3, SWIGTYPE_p_std__vectorT_double_t parameters) {
    int ret = OpenMMSwigPINVOKE.CustomHbondForce_addDonor__SWIG_0(swigCPtr, d1, d2, d3, SWIGTYPE_p_std__vectorT_double_t.getCPtr(parameters));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public int addDonor(int d1, int d2, int d3) {
    int ret = OpenMMSwigPINVOKE.CustomHbondForce_addDonor__SWIG_1(swigCPtr, d1, d2, d3);
    return ret;
  }

  public void getDonorParameters(int index, SWIGTYPE_p_int d1, SWIGTYPE_p_int d2, SWIGTYPE_p_int d3, SWIGTYPE_p_std__vectorT_double_t parameters) {
    OpenMMSwigPINVOKE.CustomHbondForce_getDonorParameters(swigCPtr, index, SWIGTYPE_p_int.getCPtr(d1), SWIGTYPE_p_int.getCPtr(d2), SWIGTYPE_p_int.getCPtr(d3), SWIGTYPE_p_std__vectorT_double_t.getCPtr(parameters));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void setDonorParameters(int index, int d1, int d2, int d3, SWIGTYPE_p_std__vectorT_double_t parameters) {
    OpenMMSwigPINVOKE.CustomHbondForce_setDonorParameters__SWIG_0(swigCPtr, index, d1, d2, d3, SWIGTYPE_p_std__vectorT_double_t.getCPtr(parameters));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void setDonorParameters(int index, int d1, int d2, int d3) {
    OpenMMSwigPINVOKE.CustomHbondForce_setDonorParameters__SWIG_1(swigCPtr, index, d1, d2, d3);
  }

  public int addAcceptor(int a1, int a2, int a3, SWIGTYPE_p_std__vectorT_double_t parameters) {
    int ret = OpenMMSwigPINVOKE.CustomHbondForce_addAcceptor__SWIG_0(swigCPtr, a1, a2, a3, SWIGTYPE_p_std__vectorT_double_t.getCPtr(parameters));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public int addAcceptor(int a1, int a2, int a3) {
    int ret = OpenMMSwigPINVOKE.CustomHbondForce_addAcceptor__SWIG_1(swigCPtr, a1, a2, a3);
    return ret;
  }

  public void getAcceptorParameters(int index, SWIGTYPE_p_int a1, SWIGTYPE_p_int a2, SWIGTYPE_p_int a3, SWIGTYPE_p_std__vectorT_double_t parameters) {
    OpenMMSwigPINVOKE.CustomHbondForce_getAcceptorParameters(swigCPtr, index, SWIGTYPE_p_int.getCPtr(a1), SWIGTYPE_p_int.getCPtr(a2), SWIGTYPE_p_int.getCPtr(a3), SWIGTYPE_p_std__vectorT_double_t.getCPtr(parameters));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void setAcceptorParameters(int index, int a1, int a2, int a3, SWIGTYPE_p_std__vectorT_double_t parameters) {
    OpenMMSwigPINVOKE.CustomHbondForce_setAcceptorParameters__SWIG_0(swigCPtr, index, a1, a2, a3, SWIGTYPE_p_std__vectorT_double_t.getCPtr(parameters));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void setAcceptorParameters(int index, int a1, int a2, int a3) {
    OpenMMSwigPINVOKE.CustomHbondForce_setAcceptorParameters__SWIG_1(swigCPtr, index, a1, a2, a3);
  }

  public int addExclusion(int donor, int acceptor) {
    int ret = OpenMMSwigPINVOKE.CustomHbondForce_addExclusion(swigCPtr, donor, acceptor);
    return ret;
  }

  public void getExclusionParticles(int index, SWIGTYPE_p_int donor, SWIGTYPE_p_int acceptor) {
    OpenMMSwigPINVOKE.CustomHbondForce_getExclusionParticles(swigCPtr, index, SWIGTYPE_p_int.getCPtr(donor), SWIGTYPE_p_int.getCPtr(acceptor));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void setExclusionParticles(int index, int donor, int acceptor) {
    OpenMMSwigPINVOKE.CustomHbondForce_setExclusionParticles(swigCPtr, index, donor, acceptor);
  }

  public int addTabulatedFunction(string name, TabulatedFunction function) {
    int ret = OpenMMSwigPINVOKE.CustomHbondForce_addTabulatedFunction(swigCPtr, name, TabulatedFunction.getCPtr(function));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public TabulatedFunction getTabulatedFunction(int index) {
    TabulatedFunction ret = new TabulatedFunction(OpenMMSwigPINVOKE.CustomHbondForce_getTabulatedFunction__SWIG_0(swigCPtr, index), false);
    return ret;
  }

  public string getTabulatedFunctionName(int index) {
    string ret = OpenMMSwigPINVOKE.CustomHbondForce_getTabulatedFunctionName(swigCPtr, index);
    return ret;
  }

  public int addFunction(string name, SWIGTYPE_p_std__vectorT_double_t values, double min, double max) {
    int ret = OpenMMSwigPINVOKE.CustomHbondForce_addFunction(swigCPtr, name, SWIGTYPE_p_std__vectorT_double_t.getCPtr(values), min, max);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public void getFunctionParameters(int index, SWIGTYPE_p_std__string name, SWIGTYPE_p_std__vectorT_double_t values, SWIGTYPE_p_double min, SWIGTYPE_p_double max) {
    OpenMMSwigPINVOKE.CustomHbondForce_getFunctionParameters(swigCPtr, index, SWIGTYPE_p_std__string.getCPtr(name), SWIGTYPE_p_std__vectorT_double_t.getCPtr(values), SWIGTYPE_p_double.getCPtr(min), SWIGTYPE_p_double.getCPtr(max));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void setFunctionParameters(int index, string name, SWIGTYPE_p_std__vectorT_double_t values, double min, double max) {
    OpenMMSwigPINVOKE.CustomHbondForce_setFunctionParameters(swigCPtr, index, name, SWIGTYPE_p_std__vectorT_double_t.getCPtr(values), min, max);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void updateParametersInContext(Context context) {
    OpenMMSwigPINVOKE.CustomHbondForce_updateParametersInContext(swigCPtr, Context.getCPtr(context));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public override bool usesPeriodicBoundaryConditions() {
    bool ret = OpenMMSwigPINVOKE.CustomHbondForce_usesPeriodicBoundaryConditions(swigCPtr);
    return ret;
  }

  public enum NonbondedMethod {
    NoCutoff = 0,
    CutoffNonPeriodic = 1,
    CutoffPeriodic = 2
  }

}

}
